rebase-i: explicitly accept tab as separator in commands
[git.git] / git-rebase--interactive.sh
blob51e0e58c679f4af6b4ede692333c4e7ea0adc8f7
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode. "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
5 # Copyright (c) 2006 Johannes E. Schindelin
7 # The original idea comes from Eric W. Biederman, in
8 # http://article.gmane.org/gmane.comp.version-control.git/22407
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user. As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
16 # The rebase command lines that have already been processed. A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands. When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it. The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
32 # The first line of the file is of the form
33 # # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated. It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit. (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be. This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
55 dropped="$state_dir"/dropped
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
80 strategy_args=
81 if test -n "$do_merge"
82 then
83 strategy_args=${strategy:+--strategy=$strategy}
84 eval '
85 for strategy_opt in '"$strategy_opts"'
87 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
88 done
92 GIT_CHERRY_PICK_HELP="$resolvemsg"
93 export GIT_CHERRY_PICK_HELP
95 comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
96 : ${comment_char:=#}
98 warn () {
99 printf '%s\n' "$*" >&2
102 # Output the commit message for the specified commit.
103 commit_message () {
104 git cat-file commit "$1" | sed "1,/^$/d"
107 orig_reflog_action="$GIT_REFLOG_ACTION"
109 comment_for_reflog () {
110 case "$orig_reflog_action" in
111 ''|rebase*)
112 GIT_REFLOG_ACTION="rebase -i ($1)"
113 export GIT_REFLOG_ACTION
115 esac
118 last_count=
119 mark_action_done () {
120 sed -e 1q < "$todo" >> "$done"
121 sed -e 1d < "$todo" >> "$todo".new
122 mv -f "$todo".new "$todo"
123 new_count=$(git stripspace --strip-comments <"$done" | wc -l)
124 echo $new_count >"$msgnum"
125 total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
126 echo $total >"$end"
127 if test "$last_count" != "$new_count"
128 then
129 last_count=$new_count
130 printf "Rebasing (%d/%d)\r" $new_count $total
131 test -z "$verbose" || echo
135 # Put the last action marked done at the beginning of the todo list
136 # again. If there has not been an action marked done yet, leave the list of
137 # items on the todo list unchanged.
138 reschedule_last_action () {
139 tail -n 1 "$done" | cat - "$todo" >"$todo".new
140 sed -e \$d <"$done" >"$done".new
141 mv -f "$todo".new "$todo"
142 mv -f "$done".new "$done"
145 append_todo_help () {
146 git stripspace --comment-lines >>"$todo" <<\EOF
148 Commands:
149 p, pick = use commit
150 r, reword = use commit, but edit the commit message
151 e, edit = use commit, but stop for amending
152 s, squash = use commit, but meld into previous commit
153 f, fixup = like "squash", but discard this commit's log message
154 x, exec = run command (the rest of the line) using shell
155 d, drop = remove commit
157 These lines can be re-ordered; they are executed from top to bottom.
160 if test $(get_missing_commit_check_level) = error
161 then
162 git stripspace --comment-lines >>"$todo" <<\EOF
163 Do not remove any line. Use 'drop' explicitly to remove a commit.
165 else
166 git stripspace --comment-lines >>"$todo" <<\EOF
167 If you remove a line here THAT COMMIT WILL BE LOST.
172 make_patch () {
173 sha1_and_parents="$(git rev-list --parents -1 "$1")"
174 case "$sha1_and_parents" in
175 ?*' '?*' '?*)
176 git diff --cc $sha1_and_parents
178 ?*' '?*)
179 git diff-tree -p "$1^!"
182 echo "Root commit"
184 esac > "$state_dir"/patch
185 test -f "$msg" ||
186 commit_message "$1" > "$msg"
187 test -f "$author_script" ||
188 get_author_ident_from_commit "$1" > "$author_script"
191 die_with_patch () {
192 echo "$1" > "$state_dir"/stopped-sha
193 make_patch "$1"
194 git rerere
195 die "$2"
198 exit_with_patch () {
199 echo "$1" > "$state_dir"/stopped-sha
200 make_patch $1
201 git rev-parse --verify HEAD > "$amend"
202 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
203 warn "You can amend the commit now, with"
204 warn
205 warn " git commit --amend $gpg_sign_opt_quoted"
206 warn
207 warn "Once you are satisfied with your changes, run"
208 warn
209 warn " git rebase --continue"
210 warn
211 exit $2
214 die_abort () {
215 rm -rf "$state_dir"
216 die "$1"
219 has_action () {
220 test -n "$(git stripspace --strip-comments <"$1")"
223 is_empty_commit() {
224 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
225 die "$1: not a commit that can be picked")
226 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
227 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
228 test "$tree" = "$ptree"
231 is_merge_commit()
233 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
236 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
237 # GIT_AUTHOR_DATE exported from the current environment.
238 do_with_author () {
240 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
241 "$@"
245 git_sequence_editor () {
246 if test -z "$GIT_SEQUENCE_EDITOR"
247 then
248 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
249 if [ -z "$GIT_SEQUENCE_EDITOR" ]
250 then
251 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
255 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
258 pick_one () {
259 ff=--ff
261 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
262 case "$force_rebase" in '') ;; ?*) ff= ;; esac
263 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
265 if is_empty_commit "$sha1"
266 then
267 empty_args="--allow-empty"
270 test -d "$rewritten" &&
271 pick_one_preserving_merges "$@" && return
272 output eval git cherry-pick \
273 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
274 "$strategy_args" $empty_args $ff "$@"
276 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
277 # previous task so this commit is not lost.
278 ret=$?
279 case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
280 return $ret
283 pick_one_preserving_merges () {
284 fast_forward=t
285 case "$1" in
287 fast_forward=f
288 sha1=$2
291 sha1=$1
293 esac
294 sha1=$(git rev-parse $sha1)
296 if test -f "$state_dir"/current-commit
297 then
298 if test "$fast_forward" = t
299 then
300 while read current_commit
302 git rev-parse HEAD > "$rewritten"/$current_commit
303 done <"$state_dir"/current-commit
304 rm "$state_dir"/current-commit ||
305 die "Cannot write current commit's replacement sha1"
309 echo $sha1 >> "$state_dir"/current-commit
311 # rewrite parents; if none were rewritten, we can fast-forward.
312 new_parents=
313 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
314 if test "$pend" = " "
315 then
316 pend=" root"
318 while [ "$pend" != "" ]
320 p=$(expr "$pend" : ' \([^ ]*\)')
321 pend="${pend# $p}"
323 if test -f "$rewritten"/$p
324 then
325 new_p=$(cat "$rewritten"/$p)
327 # If the todo reordered commits, and our parent is marked for
328 # rewriting, but hasn't been gotten to yet, assume the user meant to
329 # drop it on top of the current HEAD
330 if test -z "$new_p"
331 then
332 new_p=$(git rev-parse HEAD)
335 test $p != $new_p && fast_forward=f
336 case "$new_parents" in
337 *$new_p*)
338 ;; # do nothing; that parent is already there
340 new_parents="$new_parents $new_p"
342 esac
343 else
344 if test -f "$dropped"/$p
345 then
346 fast_forward=f
347 replacement="$(cat "$dropped"/$p)"
348 test -z "$replacement" && replacement=root
349 pend=" $replacement$pend"
350 else
351 new_parents="$new_parents $p"
354 done
355 case $fast_forward in
357 output warn "Fast-forward to $sha1"
358 output git reset --hard $sha1 ||
359 die "Cannot fast-forward to $sha1"
362 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
364 if [ "$1" != "-n" ]
365 then
366 # detach HEAD to current parent
367 output git checkout $first_parent 2> /dev/null ||
368 die "Cannot move HEAD to $first_parent"
371 case "$new_parents" in
372 ' '*' '*)
373 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
375 # redo merge
376 author_script_content=$(get_author_ident_from_commit $sha1)
377 eval "$author_script_content"
378 msg_content="$(commit_message $sha1)"
379 # No point in merging the first parent, that's HEAD
380 new_parents=${new_parents# $first_parent}
381 merge_args="--no-log --no-ff"
382 if ! do_with_author output eval \
383 'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
384 $merge_args $strategy_args -m "$msg_content" $new_parents'
385 then
386 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
387 die_with_patch $sha1 "Error redoing merge $sha1"
389 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
392 output eval git cherry-pick \
393 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
394 "$strategy_args" "$@" ||
395 die_with_patch $sha1 "Could not pick $sha1"
397 esac
399 esac
402 nth_string () {
403 case "$1" in
404 *1[0-9]|*[04-9]) echo "$1"th;;
405 *1) echo "$1"st;;
406 *2) echo "$1"nd;;
407 *3) echo "$1"rd;;
408 esac
411 update_squash_messages () {
412 if test -f "$squash_msg"; then
413 mv "$squash_msg" "$squash_msg".bak || exit
414 count=$(($(sed -n \
415 -e "1s/^. This is a combination of \(.*\) commits\./\1/p" \
416 -e "q" < "$squash_msg".bak)+1))
418 printf '%s\n' "$comment_char This is a combination of $count commits."
419 sed -e 1d -e '2,/^./{
420 /^$/d
421 }' <"$squash_msg".bak
422 } >"$squash_msg"
423 else
424 commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
425 count=2
427 printf '%s\n' "$comment_char This is a combination of 2 commits."
428 printf '%s\n' "$comment_char The first commit's message is:"
429 echo
430 cat "$fixup_msg"
431 } >"$squash_msg"
433 case $1 in
434 squash)
435 rm -f "$fixup_msg"
436 echo
437 printf '%s\n' "$comment_char This is the $(nth_string $count) commit message:"
438 echo
439 commit_message $2
441 fixup)
442 echo
443 printf '%s\n' "$comment_char The $(nth_string $count) commit message will be skipped:"
444 echo
445 # Change the space after the comment character to TAB:
446 commit_message $2 | git stripspace --comment-lines | sed -e 's/ / /'
448 esac >>"$squash_msg"
451 peek_next_command () {
452 git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
455 # A squash/fixup has failed. Prepare the long version of the squash
456 # commit message, then die_with_patch. This code path requires the
457 # user to edit the combined commit message for all commits that have
458 # been squashed/fixedup so far. So also erase the old squash
459 # messages, effectively causing the combined commit to be used as the
460 # new basis for any further squash/fixups. Args: sha1 rest
461 die_failed_squash() {
462 mv "$squash_msg" "$msg" || exit
463 rm -f "$fixup_msg"
464 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
465 warn
466 warn "Could not apply $1... $2"
467 die_with_patch $1 ""
470 flush_rewritten_pending() {
471 test -s "$rewritten_pending" || return
472 newsha1="$(git rev-parse HEAD^0)"
473 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
474 rm -f "$rewritten_pending"
477 record_in_rewritten() {
478 oldsha1="$(git rev-parse $1)"
479 echo "$oldsha1" >> "$rewritten_pending"
481 case "$(peek_next_command)" in
482 squash|s|fixup|f)
485 flush_rewritten_pending
487 esac
490 do_pick () {
491 if test "$(git rev-parse HEAD)" = "$squash_onto"
492 then
493 # Set the correct commit message and author info on the
494 # sentinel root before cherry-picking the original changes
495 # without committing (-n). Finally, update the sentinel again
496 # to include these changes. If the cherry-pick results in a
497 # conflict, this means our behaviour is similar to a standard
498 # failed cherry-pick during rebase, with a dirty index to
499 # resolve before manually running git commit --amend then git
500 # rebase --continue.
501 git commit --allow-empty --allow-empty-message --amend \
502 --no-post-rewrite -n -q -C $1 &&
503 pick_one -n $1 &&
504 git commit --allow-empty --allow-empty-message \
505 --amend --no-post-rewrite -n -q -C $1 \
506 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
507 die_with_patch $1 "Could not apply $1... $2"
508 else
509 pick_one $1 ||
510 die_with_patch $1 "Could not apply $1... $2"
514 do_next () {
515 rm -f "$msg" "$author_script" "$amend" || exit
516 read -r command sha1 rest < "$todo"
517 case "$command" in
518 "$comment_char"*|''|noop|drop|d)
519 mark_action_done
521 pick|p)
522 comment_for_reflog pick
524 mark_action_done
525 do_pick $sha1 "$rest"
526 record_in_rewritten $sha1
528 reword|r)
529 comment_for_reflog reword
531 mark_action_done
532 do_pick $sha1 "$rest"
533 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
534 warn "Could not amend commit after successfully picking $sha1... $rest"
535 warn "This is most likely due to an empty commit message, or the pre-commit hook"
536 warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
537 warn "you are able to reword the commit."
538 exit_with_patch $sha1 1
540 record_in_rewritten $sha1
542 edit|e)
543 comment_for_reflog edit
545 mark_action_done
546 do_pick $sha1 "$rest"
547 warn "Stopped at $sha1... $rest"
548 exit_with_patch $sha1 0
550 squash|s|fixup|f)
551 case "$command" in
552 squash|s)
553 squash_style=squash
555 fixup|f)
556 squash_style=fixup
558 esac
559 comment_for_reflog $squash_style
561 test -f "$done" && has_action "$done" ||
562 die "Cannot '$squash_style' without a previous commit"
564 mark_action_done
565 update_squash_messages $squash_style $sha1
566 author_script_content=$(get_author_ident_from_commit HEAD)
567 echo "$author_script_content" > "$author_script"
568 eval "$author_script_content"
569 if ! pick_one -n $sha1
570 then
571 git rev-parse --verify HEAD >"$amend"
572 die_failed_squash $sha1 "$rest"
574 case "$(peek_next_command)" in
575 squash|s|fixup|f)
576 # This is an intermediate commit; its message will only be
577 # used in case of trouble. So use the long version:
578 do_with_author output git commit --amend --no-verify -F "$squash_msg" \
579 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
580 die_failed_squash $sha1 "$rest"
583 # This is the final command of this squash/fixup group
584 if test -f "$fixup_msg"
585 then
586 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
587 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
588 die_failed_squash $sha1 "$rest"
589 else
590 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
591 rm -f "$GIT_DIR"/MERGE_MSG
592 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
593 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
594 die_failed_squash $sha1 "$rest"
596 rm -f "$squash_msg" "$fixup_msg"
598 esac
599 record_in_rewritten $sha1
601 x|"exec")
602 read -r command rest < "$todo"
603 mark_action_done
604 printf 'Executing: %s\n' "$rest"
605 # "exec" command doesn't take a sha1 in the todo-list.
606 # => can't just use $sha1 here.
607 git rev-parse --verify HEAD > "$state_dir"/stopped-sha
608 ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
609 status=$?
610 # Run in subshell because require_clean_work_tree can die.
611 dirty=f
612 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
613 if test "$status" -ne 0
614 then
615 warn "Execution failed: $rest"
616 test "$dirty" = f ||
617 warn "and made changes to the index and/or the working tree"
619 warn "You can fix the problem, and then run"
620 warn
621 warn " git rebase --continue"
622 warn
623 if test $status -eq 127 # command not found
624 then
625 status=1
627 exit "$status"
628 elif test "$dirty" = t
629 then
630 warn "Execution succeeded: $rest"
631 warn "but left changes to the index and/or the working tree"
632 warn "Commit or stash your changes, and then run"
633 warn
634 warn " git rebase --continue"
635 warn
636 exit 1
640 warn "Unknown command: $command $sha1 $rest"
641 fixtodo="Please fix this using 'git rebase --edit-todo'."
642 if git rev-parse --verify -q "$sha1" >/dev/null
643 then
644 die_with_patch $sha1 "$fixtodo"
645 else
646 die "$fixtodo"
649 esac
650 test -s "$todo" && return
652 comment_for_reflog finish &&
653 newhead=$(git rev-parse HEAD) &&
654 case $head_name in
655 refs/*)
656 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
657 git update-ref -m "$message" $head_name $newhead $orig_head &&
658 git symbolic-ref \
659 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
660 HEAD $head_name
662 esac && {
663 test ! -f "$state_dir"/verbose ||
664 git diff-tree --stat $orig_head..HEAD
665 } &&
667 test -s "$rewritten_list" &&
668 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
669 true # we don't care if this copying failed
670 } &&
671 hook="$(git rev-parse --git-path hooks/post-rewrite)"
672 if test -x "$hook" && test -s "$rewritten_list"; then
673 "$hook" rebase < "$rewritten_list"
674 true # we don't care if this hook failed
675 fi &&
676 warn "Successfully rebased and updated $head_name."
678 return 1 # not failure; just to break the do_rest loop
681 # can only return 0, when the infinite loop breaks
682 do_rest () {
683 while :
685 do_next || break
686 done
689 # skip picking commits whose parents are unchanged
690 skip_unnecessary_picks () {
691 fd=3
692 while read -r command rest
694 # fd=3 means we skip the command
695 case "$fd,$command" in
696 3,pick|3,p)
697 # pick a commit whose parent is current $onto -> skip
698 sha1=${rest%% *}
699 case "$(git rev-parse --verify --quiet "$sha1"^)" in
700 "$onto"*)
701 onto=$sha1
704 fd=1
706 esac
708 3,"$comment_char"*|3,)
709 # copy comments
712 fd=1
714 esac
715 printf '%s\n' "$command${rest:+ }$rest" >&$fd
716 done <"$todo" >"$todo.new" 3>>"$done" &&
717 mv -f "$todo".new "$todo" &&
718 case "$(peek_next_command)" in
719 squash|s|fixup|f)
720 record_in_rewritten "$onto"
722 esac ||
723 die "Could not skip unnecessary pick commands"
726 transform_todo_ids () {
727 while read -r command rest
729 case "$command" in
730 "$comment_char"* | exec)
731 # Be careful for oddball commands like 'exec'
732 # that do not have a SHA-1 at the beginning of $rest.
735 sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[ ]*}) &&
736 rest="$sha1 ${rest#*[ ]}"
738 esac
739 printf '%s\n' "$command${rest:+ }$rest"
740 done <"$todo" >"$todo.new" &&
741 mv -f "$todo.new" "$todo"
744 expand_todo_ids() {
745 transform_todo_ids
748 collapse_todo_ids() {
749 transform_todo_ids --short
752 # Rearrange the todo list that has both "pick sha1 msg" and
753 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
754 # comes immediately after the former, and change "pick" to
755 # "fixup"/"squash".
756 rearrange_squash () {
757 # extract fixup!/squash! lines and resolve any referenced sha1's
758 while read -r pick sha1 message
760 case "$message" in
761 "squash! "*|"fixup! "*)
762 action="${message%%!*}"
763 rest=$message
764 prefix=
765 # skip all squash! or fixup! (but save for later)
766 while :
768 case "$rest" in
769 "squash! "*|"fixup! "*)
770 prefix="$prefix${rest%%!*},"
771 rest="${rest#*! }"
774 break
776 esac
777 done
778 printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
779 # if it's a single word, try to resolve to a full sha1 and
780 # emit a second copy. This allows us to match on both message
781 # and on sha1 prefix
782 if test "${rest#* }" = "$rest"; then
783 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
784 if test -n "$fullsha"; then
785 # prefix the action to uniquely identify this line as
786 # intended for full sha1 match
787 echo "$sha1 +$action $prefix $fullsha"
790 esac
791 done >"$1.sq" <"$1"
792 test -s "$1.sq" || return
794 used=
795 while read -r pick sha1 message
797 case " $used" in
798 *" $sha1 "*) continue ;;
799 esac
800 printf '%s\n' "$pick $sha1 $message"
801 used="$used$sha1 "
802 while read -r squash action msg_prefix msg_content
804 case " $used" in
805 *" $squash "*) continue ;;
806 esac
807 emit=0
808 case "$action" in
810 action="${action#+}"
811 # full sha1 prefix test
812 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
814 # message prefix test
815 case "$message" in "$msg_content"*) emit=1;; esac ;;
816 esac
817 if test $emit = 1; then
818 real_prefix=$(echo "$msg_prefix" | sed "s/,/! /g")
819 printf '%s\n' "$action $squash ${real_prefix}$msg_content"
820 used="$used$squash "
822 done <"$1.sq"
823 done >"$1.rearranged" <"$1"
824 cat "$1.rearranged" >"$1"
825 rm -f "$1.sq" "$1.rearranged"
828 # Add commands after a pick or after a squash/fixup serie
829 # in the todo list.
830 add_exec_commands () {
832 first=t
833 while read -r insn rest
835 case $insn in
836 pick)
837 test -n "$first" ||
838 printf "%s" "$cmd"
840 esac
841 printf "%s %s\n" "$insn" "$rest"
842 first=
843 done
844 printf "%s" "$cmd"
845 } <"$1" >"$1.new" &&
846 mv "$1.new" "$1"
849 # Check if the SHA-1 passed as an argument is a
850 # correct one, if not then print $2 in "$todo".badsha
851 # $1: the SHA-1 to test
852 # $2: the line to display if incorrect SHA-1
853 check_commit_sha () {
854 badsha=0
855 if test -z $1
856 then
857 badsha=1
858 else
859 sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
860 if test -z $sha1_verif
861 then
862 badsha=1
866 if test $badsha -ne 0
867 then
868 warn "Warning: the SHA-1 is missing or isn't" \
869 "a commit in the following line:"
870 warn " - $2"
871 warn
874 return $badsha
877 # prints the bad commits and bad commands
878 # from the todolist in stdin
879 check_bad_cmd_and_sha () {
880 retval=0
881 git stripspace --strip-comments |
883 while read -r line
885 IFS=' '
886 set -- $line
887 command=$1
888 sha1=$2
890 case $command in
891 ''|noop|x|"exec")
892 # Doesn't expect a SHA-1
894 pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
895 if ! check_commit_sha $sha1 "$line"
896 then
897 retval=1
901 warn "Warning: the command isn't recognized" \
902 "in the following line:"
903 warn " - $line"
904 warn
905 retval=1
907 esac
908 done
910 return $retval
914 # Print the list of the SHA-1 of the commits
915 # from stdin to stdout
916 todo_list_to_sha_list () {
917 git stripspace --strip-comments |
918 while read -r command sha1 rest
920 case $command in
921 "$comment_char"*|''|noop|x|"exec")
924 long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
925 printf "%s\n" "$long_sha"
927 esac
928 done
931 # Use warn for each line in stdin
932 warn_lines () {
933 while read -r line
935 warn " - $line"
936 done
939 # Switch to the branch in $into and notify it in the reflog
940 checkout_onto () {
941 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
942 output git checkout $onto || die_abort "could not detach HEAD"
943 git update-ref ORIG_HEAD $orig_head
946 get_missing_commit_check_level () {
947 check_level=$(git config --get rebase.missingCommitsCheck)
948 check_level=${check_level:-ignore}
949 # Don't be case sensitive
950 printf '%s' "$check_level" | tr 'A-Z' 'a-z'
953 # Check if the user dropped some commits by mistake
954 # Behaviour determined by rebase.missingCommitsCheck.
955 # Check if there is an unrecognized command or a
956 # bad SHA-1 in a command.
957 check_todo_list () {
958 raise_error=f
960 check_level=$(get_missing_commit_check_level)
962 case "$check_level" in
963 warn|error)
964 # Get the SHA-1 of the commits
965 todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
966 todo_list_to_sha_list <"$todo" >"$todo".newsha1
968 # Sort the SHA-1 and compare them
969 sort -u "$todo".oldsha1 >"$todo".oldsha1+
970 mv "$todo".oldsha1+ "$todo".oldsha1
971 sort -u "$todo".newsha1 >"$todo".newsha1+
972 mv "$todo".newsha1+ "$todo".newsha1
973 comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
975 # Warn about missing commits
976 if test -s "$todo".miss
977 then
978 test "$check_level" = error && raise_error=t
980 warn "Warning: some commits may have been dropped" \
981 "accidentally."
982 warn "Dropped commits (newer to older):"
984 # Make the list user-friendly and display
985 opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
986 git rev-list $opt <"$todo".miss | warn_lines
988 warn "To avoid this message, use \"drop\" to" \
989 "explicitly remove a commit."
990 warn
991 warn "Use 'git config rebase.missingCommitsCheck' to change" \
992 "the level of warnings."
993 warn "The possible behaviours are: ignore, warn, error."
994 warn
997 ignore)
1000 warn "Unrecognized setting $check_level for option" \
1001 "rebase.missingCommitsCheck. Ignoring."
1003 esac
1005 if ! check_bad_cmd_and_sha <"$todo"
1006 then
1007 raise_error=t
1010 if test $raise_error = t
1011 then
1012 # Checkout before the first commit of the
1013 # rebase: this way git rebase --continue
1014 # will work correctly as it expects HEAD to be
1015 # placed before the commit of the next action
1016 checkout_onto
1018 warn "You can fix this with 'git rebase --edit-todo'."
1019 die "Or you can abort the rebase with 'git rebase --abort'."
1023 # The whole contents of this file is run by dot-sourcing it from
1024 # inside a shell function. It used to be that "return"s we see
1025 # below were not inside any function, and expected to return
1026 # to the function that dot-sourced us.
1028 # However, FreeBSD /bin/sh misbehaves on such a construct and
1029 # continues to run the statements that follow such a "return".
1030 # As a work-around, we introduce an extra layer of a function
1031 # here, and immediately call it after defining it.
1032 git_rebase__interactive () {
1034 case "$action" in
1035 continue)
1036 # do we have anything to commit?
1037 if git diff-index --cached --quiet HEAD --
1038 then
1039 : Nothing to commit -- skip this
1040 else
1041 if ! test -f "$author_script"
1042 then
1043 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1044 die "You have staged changes in your working tree. If these changes are meant to be
1045 squashed into the previous commit, run:
1047 git commit --amend $gpg_sign_opt_quoted
1049 If they are meant to go into a new commit, run:
1051 git commit $gpg_sign_opt_quoted
1053 In both case, once you're done, continue with:
1055 git rebase --continue
1058 . "$author_script" ||
1059 die "Error trying to find the author identity to amend commit"
1060 if test -f "$amend"
1061 then
1062 current_head=$(git rev-parse --verify HEAD)
1063 test "$current_head" = $(cat "$amend") ||
1064 die "\
1065 You have uncommitted changes in your working tree. Please, commit them
1066 first and then run 'git rebase --continue' again."
1067 do_with_author git commit --amend --no-verify -F "$msg" -e \
1068 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1069 die "Could not commit staged changes."
1070 else
1071 do_with_author git commit --no-verify -F "$msg" -e \
1072 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1073 die "Could not commit staged changes."
1077 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1079 require_clean_work_tree "rebase"
1080 do_rest
1081 return 0
1083 skip)
1084 git rerere clear
1086 do_rest
1087 return 0
1089 edit-todo)
1090 git stripspace --strip-comments <"$todo" >"$todo".new
1091 mv -f "$todo".new "$todo"
1092 collapse_todo_ids
1093 append_todo_help
1094 git stripspace --comment-lines >>"$todo" <<\EOF
1096 You are editing the todo file of an ongoing interactive rebase.
1097 To continue rebase after editing, run:
1098 git rebase --continue
1102 git_sequence_editor "$todo" ||
1103 die "Could not execute editor"
1104 expand_todo_ids
1106 exit
1108 esac
1110 git var GIT_COMMITTER_IDENT >/dev/null ||
1111 die "You need to set your committer info first"
1113 comment_for_reflog start
1115 if test ! -z "$switch_to"
1116 then
1117 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1118 output git checkout "$switch_to" -- ||
1119 die "Could not checkout $switch_to"
1121 comment_for_reflog start
1124 orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
1125 mkdir -p "$state_dir" || die "Could not create temporary $state_dir"
1127 : > "$state_dir"/interactive || die "Could not mark as interactive"
1128 write_basic_state
1129 if test t = "$preserve_merges"
1130 then
1131 if test -z "$rebase_root"
1132 then
1133 mkdir "$rewritten" &&
1134 for c in $(git merge-base --all $orig_head $upstream)
1136 echo $onto > "$rewritten"/$c ||
1137 die "Could not init rewritten commits"
1138 done
1139 else
1140 mkdir "$rewritten" &&
1141 echo $onto > "$rewritten"/root ||
1142 die "Could not init rewritten commits"
1144 # No cherry-pick because our first pass is to determine
1145 # parents to rewrite and skipping dropped commits would
1146 # prematurely end our probe
1147 merges_option=
1148 else
1149 merges_option="--no-merges --cherry-pick"
1152 shorthead=$(git rev-parse --short $orig_head)
1153 shortonto=$(git rev-parse --short $onto)
1154 if test -z "$rebase_root"
1155 # this is now equivalent to ! -z "$upstream"
1156 then
1157 shortupstream=$(git rev-parse --short $upstream)
1158 revisions=$upstream...$orig_head
1159 shortrevisions=$shortupstream..$shorthead
1160 else
1161 revisions=$onto...$orig_head
1162 shortrevisions=$shorthead
1164 git rev-list $merges_option --pretty=oneline --reverse --left-right --topo-order \
1165 $revisions ${restrict_revision+^$restrict_revision} | \
1166 sed -n "s/^>//p" |
1167 while read -r sha1 rest
1170 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1171 then
1172 comment_out="$comment_char "
1173 else
1174 comment_out=
1177 if test t != "$preserve_merges"
1178 then
1179 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1180 else
1181 if test -z "$rebase_root"
1182 then
1183 preserve=t
1184 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1186 if test -f "$rewritten"/$p
1187 then
1188 preserve=f
1190 done
1191 else
1192 preserve=f
1194 if test f = "$preserve"
1195 then
1196 touch "$rewritten"/$sha1
1197 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1200 done
1202 # Watch for commits that been dropped by --cherry-pick
1203 if test t = "$preserve_merges"
1204 then
1205 mkdir "$dropped"
1206 # Save all non-cherry-picked changes
1207 git rev-list $revisions --left-right --cherry-pick | \
1208 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1209 # Now all commits and note which ones are missing in
1210 # not-cherry-picks and hence being dropped
1211 git rev-list $revisions |
1212 while read rev
1214 if test -f "$rewritten"/$rev && test "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
1215 then
1216 # Use -f2 because if rev-list is telling us this commit is
1217 # not worthwhile, we don't want to track its multiple heads,
1218 # just the history of its first-parent for others that will
1219 # be rebasing on top of it
1220 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1221 sha1=$(git rev-list -1 $rev)
1222 sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1223 rm "$rewritten"/$rev
1225 done
1228 test -s "$todo" || echo noop >> "$todo"
1229 test -n "$autosquash" && rearrange_squash "$todo"
1230 test -n "$cmd" && add_exec_commands "$todo"
1232 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1233 todocount=${todocount##* }
1235 cat >>"$todo" <<EOF
1237 $comment_char Rebase $shortrevisions onto $shortonto ($todocount command(s))
1239 append_todo_help
1240 git stripspace --comment-lines >>"$todo" <<\EOF
1242 However, if you remove everything, the rebase will be aborted.
1246 if test -z "$keep_empty"
1247 then
1248 printf '%s\n' "$comment_char Note that empty commits are commented out" >>"$todo"
1252 has_action "$todo" ||
1253 return 2
1255 cp "$todo" "$todo".backup
1256 collapse_todo_ids
1257 git_sequence_editor "$todo" ||
1258 die_abort "Could not execute editor"
1260 has_action "$todo" ||
1261 return 2
1263 check_todo_list
1265 expand_todo_ids
1267 test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1269 checkout_onto
1270 do_rest
1273 # ... and then we call the whole thing.
1274 git_rebase__interactive